/* 
 * Ilya Birmans iScrollbar
 * as seen on an iPhone!
 * Copyright  2007 by Ilya Birman
 * http://ilyabirman.ru/tools/iscroll/

 */


document.addEventListener ('load', function (e) {

  if (document.iScrollbars) return

  document.iScrollbars = document.createElement ('div');

  document.iScrollbars.initialDisplay = true
  document.iScrollbars.scrollbarColor = 'auto'
  document.iScrollbars.sideSpacing = 4
  document.iScrollbars.edgeSpacing = 4
  document.iScrollbars.scrollbarWidth = 4
  document.iScrollbars.gainOpacity = false
  document.iScrollbars.opacityMax = .75
  document.iScrollbars.opacityStep = .025
  document.iScrollbars.moveSoftness = 10 // 1 for no, more for more, 10 is just fine
  document.iScrollbars.fadeTimeout = 100
  document.iScrollbars.microTimeout = 10
  document.iScrollbars.horThresh = 1
  document.iScrollbars.verThresh = 1

  if (document.iScrollbars.scrollbarColor == 'auto') {
    var bodyBG = document.defaultView.getComputedStyle (document.body, null).backgroundColor.toString ()
    var bodyBGR = bodyBG.substr (1,1)
    if (isNaN (bodyBGR)) bodyBGR = bodyBGR.charCodeAt (0) - 92
    var bodyBGG = bodyBG.substr (3,1)
    if (isNaN (bodyBGG)) bodyBGG = bodyBGG.charCodeAt (0) - 92
    var bodyBGB = bodyBG.substr (5,1)
    if (isNaN (bodyBGB)) bodyBGB = bodyBGB.charCodeAt (0) - 92
    var bodyBGAve = (bodyBGR*1 + bodyBGG*1 + bodyBGB*1) / 3
    document.iScrollbars.scrollbarColor = '#000'
    if (bodyBGAve < 8) document.iScrollbars.scrollbarColor = '#fff'
  }

  document.iScrollbarV = document.createElement ('div');
  document.iScrollbarV.style.position = 'fixed'
  document.iScrollbarV.style.opacity = '0'
  document.iScrollbarV.style.zIndex = '1000'
  document.iScrollbarV.style.backgroundColor = document.iScrollbars.scrollbarColor
  document.iScrollbarV.style.right = document.iScrollbars.sideSpacing + 'px'
  document.iScrollbarV.style.width = document.iScrollbars.scrollbarWidth + 'px'

  document.iScrollbarH = document.createElement ('div');
  document.iScrollbarH.style.position = 'fixed'
  document.iScrollbarH.style.opacity = '0'
  document.iScrollbarH.style.zIndex = '1000'
  document.iScrollbarH.style.backgroundColor = document.iScrollbars.scrollbarColor
  document.iScrollbarH.style.bottom = document.iScrollbars.sideSpacing + 'px'
  document.iScrollbarH.style.height = document.iScrollbars.scrollbarWidth + 'px'

  document.iScrollbars.appendChild (document.iScrollbarV)
  document.iScrollbars.appendChild (document.iScrollbarH)

  document.body.appendChild (document.iScrollbars)

  var _t1, _t2, _top_from, _top_to, _top_now, _left_from, _left_to, _left_now
  _top_from = _top_to = _top_now = false
  _left_from = _left_to = _left_now = false

  document.iScrollbars.moveScrollbars = function () {
    if (_t2) clearTimeout (_t2)
    _t1 = setTimeout ('document.iScrollbars.moveScrollbars ()', document.iScrollbars.microTimeout)

    var _top_new = _top_now + (_top_to-_top_now) / document.iScrollbars.moveSoftness
    if (_top_to > _top_now) _top_now = Math.ceil (_top_new)
    if (_top_to < _top_now) _top_now = Math.floor (_top_new)
    if (document.iScrollbars.gainOpacity) {
      document.iScrollbarV.style.opacity =
        document.iScrollbars.opacityMax * Math.abs (_top_now-_top_from) / Math.abs (_top_to-_top_from)
    }
    document.iScrollbarV.style.top = _top_now + 'px'

    var _left_new = _left_now + (_left_to-_left_now) / document.iScrollbars.moveSoftness
    if (_left_to > _left_now) _left_now = Math.ceil (_left_new)
    if (_left_to < _left_now) _left_now = Math.floor (_left_new)
    if (document.iScrollbars.gainOpacity) {
      document.iScrollbarH.style.opacity =
        document.iScrollbars.opacityMax * Math.abs (_left_now-_left_from) / Math.abs (_left_to-_left_from)
    }
    document.iScrollbarH.style.left = _left_now + 'px'

    if ((_top_now == _top_to) && (_left_now == _left_to)) {
      clearTimeout (_t1)
      _t2 = setTimeout ('document.iScrollbars.fadeScrollbars ()', document.iScrollbars.fadeTimeout)
    }
  }

  document.iScrollbars.fadeScrollbars = function () {
    clearTimeout (_t2)
    _t2 = setTimeout ('document.iScrollbars.fadeScrollbars ()', document.iScrollbars.microTimeout)
    var _done = true
    if (document.iScrollbarV.style.opacity > 0) {
      document.iScrollbarV.style.opacity -= document.iScrollbars.opacityStep
      _done = false
    }
    if (document.iScrollbarH.style.opacity > 0) {
      document.iScrollbarH.style.opacity -= document.iScrollbars.opacityStep
      _done = false
    }
    if (_done) clearTimeout (_t2)
  }

  document.iScrollbars.updateScrollbars = function () {

    // vertical

    var zoneHeight = document.body.clientHeight - document.iScrollbars.edgeSpacing * 2
    var partitionY = document.body.clientHeight / document.body.scrollHeight
    var scrollbarHeight = Math.round (partitionY * zoneHeight)
    var variationY = zoneHeight // - scrollbarHeight
    var positionY = document.body.scrollTop / document.body.scrollHeight
    var scrollbarTop = Math.round (document.iScrollbars.edgeSpacing + variationY * positionY)
    _top_from = _top_now
    _top_to = scrollbarTop

    if ((partitionY < 1/document.iScrollbars.verThresh) && (_top_from != _top_to)) {
      if (_top_now === false) {
        _top_now = _top_to
        if (document.iScrollbars.gainOpacity) {
          document.iScrollbarV.style.opacity = document.iScrollbars.opacityMax
        }
        document.iScrollbarV.style.top = _top_now + 'px'
      }
      document.iScrollbarV.style.height = scrollbarHeight + 'px'
      if (!document.iScrollbars.gainOpacity) {
        document.iScrollbarV.style.opacity = document.iScrollbars.opacityMax
      }
    }

    // horizontal

    var zoneWidth = document.body.clientWidth - document.iScrollbars.edgeSpacing * 2
    var partitionX = document.body.clientWidth / document.body.scrollWidth
    var scrollbarWidth = Math.round (partitionX * zoneWidth)
    var variationX = zoneWidth // - scrollbarWidth
    var positionX = document.body.scrollLeft / document.body.scrollWidth
    var scrollbarLeft = Math.round (document.iScrollbars.edgeSpacing + variationX * positionX)
    _left_from = _left_now
    _left_to = scrollbarLeft

    if ((partitionX < 1/document.iScrollbars.horThresh) && (_left_from != _left_to)) {
      if (_left_now === false) {
        _left_now = _left_to
        if (document.iScrollbars.gainOpacity) {
          document.iScrollbarH.style.opacity = document.iScrollbars.opacityMax
        }
        document.iScrollbarH.style.left = _left_now + 'px'
      }
      document.iScrollbarH.style.width = scrollbarWidth + 'px'
      if (!document.iScrollbars.gainOpacity) {
        document.iScrollbarH.style.opacity = document.iScrollbars.opacityMax
      }
    }
    
    document.iScrollbars.moveScrollbars ()

  }

  if (document.iScrollbars.initialDisplay) document.iScrollbars.updateScrollbars ()
  document.addEventListener ('scroll', document.iScrollbars.updateScrollbars, false) 

}, false)
